const User = require('../models/auth/user.model');
const Heroe = require('../models/herocorp/heroe.model')
const bcrypt = require('bcryptjs');
const SALT_WORK_FACTOR = 10;

let superdupond = null
let baguettor = null
let chatounette = null
let maddog = null
let supertutu = null

async function getHeroes() {

  try {
    superdupond = await Heroe.findOne({publicName: 'super dupond'}).exec()
    baguettor = await Heroe.findOne({publicName: 'baguettor'}).exec()
    chatounette = await Heroe.findOne({publicName: 'chatounette'}).exec()
    maddog = await Heroe.findOne({publicName: 'mad dog'}).exec()
    supertutu = await Heroe.findOne({publicName: 'super tutu'}).exec()
  }
  catch(err) {
    console.log('cannot get heroes')
  }
}

async function initUsers() {

  // create superdupond user
  User.findOne({login: 'superdupond'}, (err, test) => {
    if (err) {
      console.log('cannot verify if test user already exists')
    }
    else if (!test) {
      const salt = bcrypt.genSaltSync(SALT_WORK_FACTOR);
      const password = bcrypt.hashSync('azer', salt);
      new User({
        login: "superdupond",
        password: password,
        hero: superdupond._id,
      }).save(err => {
        if (err) {
          console.log("error", err);
        }
        console.log("added superdupond to users collection");
      });
    }
  });
  // create baguettor user
  User.findOne({login: 'baguettor'}, (err, test) => {
    if (err) {
      console.log('cannot verify if user already exists')
    }
    else if (!test) {
      const salt = bcrypt.genSaltSync(SALT_WORK_FACTOR);
      const password = bcrypt.hashSync('azer', salt);
      new User({
        login: "baguettor",
        password: password,
        hero: baguettor._id,
      }).save(err => {
        if (err) {
          console.log("error", err);
        }
        console.log("added baguettor to users collection");
      });
    }
  });
// create chatounette user
  User.findOne({login: 'chatounette'}, (err, test) => {
    if (err) {
      console.log('cannot verify if user already exists')
    }
    else if (!test) {
      const salt = bcrypt.genSaltSync(SALT_WORK_FACTOR);
      const password = bcrypt.hashSync('azer', salt);
      new User({
        login: "chatounette",
        password: password,
        hero: chatounette._id,
      }).save(err => {
        if (err) {
          console.log("error", err);
        }
        console.log("added chatounette to users collection");
      });
    }
  });
// create maddog user
  User.findOne({login: 'maddog'}, (err, test) => {
    if (err) {
      console.log('cannot verify if user already exists')
    }
    else if (!test) {
      const salt = bcrypt.genSaltSync(SALT_WORK_FACTOR);
      const password = bcrypt.hashSync('azer', salt);
      new User({
        login: "maddog",
        password: password,
        hero: maddog._id,
      }).save(err => {
        if (err) {
          console.log("error", err);
        }
        console.log("added maddog to users collection");
      });
    }
  });
// create supertutu user
  User.findOne({login: 'supertutu'}, (err, test) => {
    if (err) {
      console.log('cannot verify if user already exists')
    }
    else if (!test) {
      const salt = bcrypt.genSaltSync(SALT_WORK_FACTOR);
      const password = bcrypt.hashSync('azer', salt);
      new User({
        login: "supertutu",
        password: password,
        hero: supertutu._id,
      }).save(err => {
        if (err) {
          console.log("error", err);
        }
        console.log("added supertutu to users collection");
      });
    }
  });

}

async function initBdD() {
  await getHeroes()
  await initUsers()
}

module.exports = {
  initBdD,
};


