const Heroe = require('../models/herocorp/heroe.model')
const Team = require('../models/herocorp/team.model')
const Organization = require('../models/herocorp/organization.model')

const bcrypt = require('bcryptjs');
const SALT_WORK_FACTOR = 10;

let superdupond = null
let baguettor = null
let chatounette = null
let maddog = null
let supertutu = null

let cocoricoteam = null
let bastardsteam = null
let voidteam = null

let orggood = null
let orgbad = null

async function initHeroes() {
  try {
    superdupond = await Heroe.findOne({publicName: 'super dupond'}).exec()
    if (superdupond === null) {
      superdupond = new Heroe({
        publicName: "super dupond",
        realName: "jean dupond",
        powers: [
          {name: "super biscottos", type: 1, level: 75},
          {name: "super ducon", type: 6, level: 50},
        ] 
      })
      superdupond = await superdupond.save()
      console.log("added super dupond to heroes collection")
    }
  }
  catch(err) {
    console.log('cannot verify/create superdupond user')
  }
  try {
    baguettor = await Heroe.findOne({publicName: 'baguettor'}).exec()
    if (baguettor === null) {
      baguettor = new Heroe({
        publicName: "baguettor",
        realName: "pierre pierre",
        powers: [
          {name: "gros pain", type: 1, level: 50},
          {name: "pain dur", type: 3, level: 75},
        ]
      })
      baguettor = await baguettor.save()
      console.log("added baguettor to heroes collection")
    }
  }
  catch(err) {
    console.log('cannot verify/create baguettor user')
  }
  try {
    chatounette = await Heroe.findOne({publicName: 'chatounette'}).exec()
    if (chatounette === null) {
      chatounette = new Heroe({
        publicName: "chatounette",
        realName: "julia ford",
        powers: [
          {name: "fastorun", type: 2, level: 75},
          {name: "chatdeau", type: 3, level: 75},
        ]
      })
      chatounette = await chatounette.save()
      console.log("added chatounette to heroes collection")
    }
  }
  catch(err) {
    console.log('cannot verify/create chatounette user')
  }
  try {
    maddog = await Heroe.findOne({publicName: 'mad dog'}).exec()
    if (maddog === null) {
      maddog = new Heroe({
        publicName: "mad dog",
        realName: "jules ford",
        powers: [
          {name: "megamoche", type: 5, level: 99},
          {name: "megadumb", type: 6, level: 100},
        ]
      })
      maddog = await maddog.save()
      console.log("added maddog to heroes collection")
    }
  }
  catch(err) {
    console.log('cannot verify/create maddog user')
  }
  try {
    supertutu = await Heroe.findOne({publicName: 'super tutu'}).exec()
    if (supertutu === null) {
      supertutu = new Heroe({
        publicName: "super tutu",
        realName: "toto",
        powers: [
          {name: "blaguonulle", type: 6, level: 25},
        ]
      })
      supertutu = await supertutu.save()
      console.log("added supertutu to heroes collection")
    }
  }
  catch(err) {
    console.log('cannot verify/create supertutu user')
  }
}

async function initTeams() {
  try {
    cocoricoteam = await Team.findOne({name: 'Cocorico squad'}).exec()
    if (cocoricoteam === null) {
      cocoricoteam = new Team({
        name: 'Cocorico squad',
        members: [ superdupond._id, baguettor._id],
      })
      cocoricoteam = await cocoricoteam.save()
      console.log("added cocorico squad to team collection")
    }
  } catch (err) {
    console.log('cannot verify/create cocorico squad team')
  }
  try {
    bastardsteam = await Team.findOne({name: 'Bastard twins'}).exec()
    if (bastardsteam === null) {
      bastardsteam = new Team({
        name: 'Bastard twins',
        members: [ chatounette._id, maddog._id],
      })
      bastardsteam = await bastardsteam.save()
      console.log("added bastard twins to team collection")
    }
  } catch (err) {
    console.log('cannot verify/create bastard twins team')
  }
  try {
    voidteam = await Team.findOne({name: 'Void team'}).exec()
    if (voidteam === null) {
      voidteam = new Team({
        name: 'Void team',
        members: [ ],
      })
      voidteam = await voidteam.save()
      console.log("added void team to team collection")
    }
  } catch (err) {
    console.log('cannot verify/create void team')
  }
}

async function initOrganizations() {
  try {
    orggood = await Organization.findOne({name: 'Herocorp'}).exec()
    if (orggood === null) {
      orggood = new Organization({
        name: 'Herocorp',
        secret: 'nous sommes gentils',
        teams: [cocoricoteam._id],
      })
      orggood = await orggood.save()
      console.log("added herocorp to organization collection")
    }
      else {
	    console.log('herocorp organization already exists. Do nothing')
      }
  } catch (err) {
    console.log('cannot verify/create herocorp organization')
  }
  try {
    orgbad = await Organization.findOne({name: 'Vilaincorp'}).exec()
    if (orgbad === null) {
      orgbad = new Organization({
        name: 'Vilaincorp',
        secret: 'nous sommes mechants',
        teams: [bastardsteam._id, voidteam._id],
      })
      orgbad = await orgbad.save()
      console.log("added vilaincorp to organization collection")
    }
      else {
	    console.log('vilaincorp organization already exists. Do nothing')
      }
  } catch (err) {
    console.log('cannot verify/create vilaincorp organization')
  }
}
async function initBdD() {
  await initHeroes()
  await initTeams()
  await initOrganizations()
}

module.exports = {
  initBdD,
};


